/*
   crc.cpp
   Computes the CRC32 of a file
*/
#include <stdio.h>
#include <compress.h>

unsigned char buffer[1024];

int main(int argc,char *argv[])
{
   STREAM *fp;
   unsigned long size, crc;

   if(argc != 2) {
      fprintf(stderr,"Usage: CRC <filename>\n");
      return 1;
   }

   fp = stream_open(argv[1],"rb");
   if(!fp) {
      fprintf(stderr,"Can't open file `%s'.\n",argv[1]);
      return 1;
   }

   init_crc_table();
   crc = 0;
   while((size = stream_read(buffer,1,1024,fp)) > 0) {
      crc = update_crc(crc,buffer,size);
   }

   printf("CRC32: %.8lX\n",crc);

   stream_close(fp);
   return 0;
}